package fractal;

import java.awt.Canvas;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Graphics;

public class ImageCanvas extends Canvas {
  public static final int WIDTH = Renderer3D.WIDTH, HEIGHT = Renderer3D.HEIGHT;
  protected Lm pappy_;
  protected Dimension size_;
  protected Image imageBuffer_;
  protected boolean firstTime = true;

  public ImageCanvas(Lm highestContainer) {
    this.pappy_ = highestContainer;
    size_ = new Dimension(WIDTH, HEIGHT);
    imageBuffer_ = null;
  }

  public Dimension getPreferredSize()
    {
      return size_;
    }

  public Dimension getMinimumSize()
    {
      return size_;
    }

  public void paint(Graphics g) 
    {
        if(pappy_.modified_)
          {
            pappy_.modified_ = false;
            Grammar gr = null;
            try
              {
                gr = new Grammar(pappy_.rules_);
              }
            catch(Exception e)
              {
                System.err.println("exception: " + e + " at");
                e.printStackTrace();
              }
            for(int i = 1; i < pappy_.n_; i++)
                gr.nextStep();
            String step = gr.nextStep();
            Model3D m = new Model3D(pappy_.d_, 
                    2 * Math.PI * pappy_.angle_ / 360, step);
            Renderer r = new Renderer3D(m.getModel(), pappy_);
            Image image = r.getImage();
            imageBuffer_ = image;

            g.drawImage(imageBuffer_, 0, 0, pappy_);
            if(firstTime)
              {
                firstTime = false;
                size_ = new Dimension(imageBuffer_.getWidth(this),
                                    imageBuffer_.getHeight(this));
                pappy_.validate();
              }
          }
        else
          {
            g.drawImage(imageBuffer_, 0, 0, pappy_);
          }
   }


  public void update(Graphics g) {
    paint(g);
  }

  public Image getBuffer()
    {
      return imageBuffer_;
    }
}
